import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { ShopBrand, ShopBrandParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询品牌
 */
export async function pageShopBrand(params: ShopBrandParam) {
  const res = await request.get<ApiResult<PageResult<ShopBrand>>>(
    MODULES_API_URL + '/mall/shop-brand/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询品牌列表
 */
export async function listShopBrand(params?: ShopBrandParam) {
  const res = await request.get<ApiResult<ShopBrand[]>>(
    MODULES_API_URL + '/mall/shop-brand',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加品牌
 */
export async function addShopBrand(data: ShopBrand) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-brand',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改品牌
 */
export async function updateShopBrand(data: ShopBrand) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-brand',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除品牌
 */
export async function removeShopBrand(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-brand/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除品牌
 */
export async function removeBatchShopBrand(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/mall/shop-brand/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询品牌
 */
export async function getShopBrand(id: number) {
  const res = await request.get<ApiResult<ShopBrand>>(
    MODULES_API_URL + '/mall/shop-brand/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
